import _extends from "babel-runtime/helpers/extends";
import _Object$getPrototypeOf from "babel-runtime/core-js/object/get-prototype-of";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import _possibleConstructorReturn from "babel-runtime/helpers/possibleConstructorReturn";
import _inherits from "babel-runtime/helpers/inherits";
import React from "react";
import ReactDOM from "react-dom";
import copy from "copy-to-clipboard";
import PropTypes from "prop-types";
import Style from "./style.scss";

var Copy = function (_React$Component) {
  _inherits(Copy, _React$Component);

  // static defaultProps = {
  //     value: '',
  //     onCopy: () => {},
  //     onChange: () => {},
  // }

  function Copy(props) {
    _classCallCheck(this, Copy);

    var _this = _possibleConstructorReturn(this, (Copy.__proto__ || _Object$getPrototypeOf(Copy)).call(this, props));

    _this.ref = null;

    _this.handleCopy = function (e) {
      var onCopy = _this.props.onCopy;

      var value = _this.ref.current.value;
      var result = copy(value);
      if (typeof onCopy === "function") {
        onCopy(result);
      }
    };

    _this.handleChange = function (e) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          value = _this$props.value;

      if (typeof onChange === "function") {
        onChange(e.target.value);
      }
    };

    _this.getInputOptions = function () {
      var _this$props2 = _this.props,
          value = _this$props2.value,
          defaultValue = _this$props2.defaultValue,
          onChange = _this$props2.onChange;

      var options = {};
      if ("defaultValue" in _this.props) {
        options.defaultValue = defaultValue;
      }
      if ("value" in _this.props) {
        options.value = value;
      }
      if ("onChange" in _this.props) {
        options.onChange = _this.handleChange;
      }
      return options;
    };

    _this.getBtnOptions = function () {
      var enterButton = _this.props.enterButton;

      var options = {
        onClick: _this.handleCopy
      };

      if (typeof enterButton === "string") {
        return;
      }

      return options;
    };

    _this.getButton = function () {
      var enterButton = _this.props.enterButton;

      if (typeof enterButton === "string") {
        return React.createElement(
          "button",
          { className: "copy-btn", onClick: _this.handleCopy },
          enterButton
        );
      }
      if (React.isValidElement(enterButton)) {
        return enterButton;
      }
      return React.createElement(
        "button",
        { className: "copy-btn" },
        "copy"
      );
    };

    _this.ref = React.createRef();
    return _this;
  }

  _createClass(Copy, [{
    key: "render",
    value: function render() {
      var Button = this.getButton();
      return React.createElement(
        "div",
        { className: Style.copy },
        React.createElement("input", _extends({
          ref: this.ref,
          className: "copy-input"
        }, this.getInputOptions())),
        React.createElement(
          "span",
          { className: "copy-btn-wrapper" },
          Button
        )
      );
    }
  }]);

  return Copy;
}(React.Component);

Copy.propTypes = {
  defaultValue: PropTypes.string.isRequired,
  value: PropTypes.string.isRequired,
  onCopy: PropTypes.func,
  onChange: PropTypes.func,
  copyButton: PropTypes.any
};


export default Copy;